import java.util.*;
import java.net.Socket;
import java.io.*;

public class DCCTransfer extends Thread
{
	String srcaddr;
	int srcport;
	long filesize;
	Socket dccsocket;
	FileOutputStream receivedfile;
	String filename;
	
	DCCTransfer(String tfilename, String tsrcaddr, int tsrcPort, long tfileSize)
	{
		srcaddr = tsrcaddr;
		srcport = tsrcPort;
		filesize = tfileSize;
		filename = tfilename;
		setDaemon(true);
		this.start();
	}
	
	int max(int a, int b)
	{
		if (a > b)
			return b;
		else
			return a;
	}
	
	void showbits(byte b)
	{
		String outstring = new String("");
		for (int x = 0; x < 8; x++)
		{
			if (((b >>> x) & 0x01) == 0)
				outstring = outstring + "0";
			 else
			 	outstring = outstring + "1";
		}
		System.out.println(outstring);
	}
	
	public void run()
	{
		byte databuf[] = new byte[2048+1]; 
		dccsocket = null;
		try
	{
		int bytesreceived = 0;
		byte testout = 0;
	  int totalreceived = 0;
		dccsocket = new Socket(srcaddr,srcport);
		InputStream filercvstream = dccsocket.getInputStream();
		OutputStream statussend = dccsocket.getOutputStream();
		receivedfile = new FileOutputStream(filename);
		while(bytesreceived != -1)
		{
			if (filercvstream.available() > 1)
			{
			System.out.println("waiting for data");
			bytesreceived = filercvstream.read(databuf,0,1024);
			System.out.println("got data");
		  if (bytesreceived > 0)
		  {
		  	System.out.println("writing to file");
		  	receivedfile.write(databuf,0,bytesreceived);
		  	totalreceived += bytesreceived;
		  	byte outputbuf[] = new byte[4];
		  	outputbuf[3] = (byte) (((((totalreceived) >>> 32)) & 0xFF));
		  	outputbuf[2] = (byte) (((((totalreceived) >>> 24)) & 0xFF));
		  	outputbuf[1] = (byte) (((((totalreceived) >>> 16 )) & 0xFF));
		  	outputbuf[0] = (byte) (((((totalreceived) >>> 8 )) & 0xFF));
		  	/*try { sleep(1000); }
		  	catch (InterruptedException v) { }  */
		  	System.out.println("sending ACK");
		  	statussend.write(outputbuf, 0, 4);
		  	System.out.println("flushing");
		  	statussend.flush();
		  	System.out.println(Long.toString(totalreceived)+ " " +Long.toString(bytesreceived));
		  }
		//	bytesreceived =1;
			}
			if (bytesreceived == -1) { 
				receivedfile.close(); 
				System.out.println(" closing receive file");
			}
		}
		System.out.println("Closed socket");
		dccsocket.close();
	}
		catch(java.io.IOException e)
		{
			System.out.println("Couldn't connect to remote host/Lost connection: "+e.getMessage());
		}
	}
}